# friendly

Aimed at Python beginners: replacing standard traceback by something easier to understand,
translatable into various languages. **friendly** can provide additional
information such as `why()` a certain exception occurred,
`what()` it is, exactly `where()` it occurred including
the value of relevant variables, and
[more](https://aroberge.github.io/friendly-traceback-docs/docs/html/).


![Example](https://raw.githubusercontent.com/aroberge/friendly/master/why_1.png)

**friendly** used to be called **friendly-traceback**.


## Installation

```
pip install friendly
```

## Documentation

[The documentation is available by clicking here.](https://aroberge.github.io/friendly-traceback-docs/docs/html/)

## Example

![Example](https://raw.githubusercontent.com/aroberge/friendly/master/explain.png)


## Contribute

Contribute by making suggestions for improvements, pointing out mistakes either in
the documentation or in the information provided by Friendly, or finding bugs.

If you speak a language other than English or French and feel ambitious, you might
want to work on translations into your own language.

## License: MIT

Some of the ideas were adopted from
[DidYouMean-Python (aka BetterErrorMessages)](https://github.com/SylvainDe/DidYouMean-Python)
by Sylvain Desodt, a project that is also using the MIT license.

## Code of Conduct

We agree with the goals behind the creation of the
[Python Community Code of Conduct](https://www.python.org/psf/codeofconduct/).
Contributors to this project, including those filing or commenting on an issue,
are expected to do the same.


## JetBrains support

We graciously acknowledge the support of [JetBrains](
https://www.jetbrains.com/?from=friendly-traceback)
which enables us to use the professional version
of PyCharm for developing Friendly.
